'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.AtomSpinnerTypes = undefined;

var _values = require('babel-runtime/core-js/object/values');

var _values2 = _interopRequireDefault(_values);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _SUILoader = require('./SUILoader');

var _SUILoader2 = _interopRequireDefault(_SUILoader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var TYPES = {
  FULL: 'full',
  SECTION: 'section'
};

var DELAY = 500; // ms
var BASE_CLASS = 'sui-AtomSpinner';

var AtomSpinner = function (_Component) {
  (0, _inherits3.default)(AtomSpinner, _Component);

  function AtomSpinner() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, AtomSpinner);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = AtomSpinner.__proto__ || (0, _getPrototypeOf2.default)(AtomSpinner)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      delayed: _this.props.delayed
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(AtomSpinner, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      if (!this.state.delayed) {
        this._addParentClass();
        return;
      }

      this.timer = setTimeout(function () {
        _this2.setState({ delayed: false }, _this2._addParentClass);
      }, DELAY);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearTimeout(this.timer);
      this._removeParentClass();
    }
  }, {
    key: '_removeParentClass',
    value: function _removeParentClass() {
      this._parentNodeClassList.remove(this._parentClassName);
    }
  }, {
    key: '_addParentClass',
    value: function _addParentClass() {
      this._parentNodeClassList.add(this._parentClassName);
    }
  }, {
    key: 'render',
    value: function render() {
      var loader = this.props.loader;
      var delayed = this.state.delayed;

      return !delayed ? loader : _react2.default.createElement('noscript', null);
    }
  }, {
    key: '_parentNodeClassList',
    get: function get() {
      if (this._parentNodeClassListCache) return this._parentNodeClassListCache;

      this._parentNodeClassListCache = _reactDom2.default.findDOMNode(this).parentNode.classList;
      return this._parentNodeClassListCache;
    }
  }, {
    key: '_parentClassName',
    get: function get() {
      var type = this.props.type;


      return (0, _classnames2.default)(type === TYPES.SECTION ? BASE_CLASS : BASE_CLASS + '--fullPage');
    }
  }]);
  return AtomSpinner;
}(_react.Component);

AtomSpinner.displayName = 'AtomSpinner';

AtomSpinner.propTypes = process.env.NODE_ENV !== "production" ? process.env.NODE_ENV !== "production" ? {
  /**
   * Possible options:
   * 'FULL': The spinner fits the whole page container
   * 'SECTION': The spinner fits a specific site component
   */
  type: _propTypes2.default.oneOf((0, _values2.default)(TYPES)),
  /**
   * Makes the spinner appear after 500 ms
   */
  delayed: _propTypes2.default.bool,
  /**
   * Loader to be shown in the middle of the container
   */
  loader: _propTypes2.default.object
} : {} : {};

AtomSpinner.defaultProps = {
  delayed: false,
  type: TYPES.SECTION,
  loader: _react2.default.createElement(_SUILoader2.default, { text: 'Loading...' })
};

exports.default = AtomSpinner;
exports.AtomSpinnerTypes = TYPES;